#
# This file is part of the Poke package
#
# (c) 2014 Julien Brochet <mewt@madalynn.eu>
#
# For the full copyright and license information, please view the LICENSE
# file that was distributed with this source code.
#

require 'nokogiri'
require 'open-uri'

module Poke
  module Checks
    module Blacklist
      class FreeBlacklistCheck < Poke::Check
        def initialize(ip)
          name = "Blacklist of #{ip} (postmaster free)"
          @ip = ip
          super name
        end

        # Run the check
        def run
          html = URI.parse("http://postmaster.free.fr/showipstate.pl?ip=#{@ip}").read
          doc = Nokogiri::HTML(html)
          nodes = doc.search("//div[@class='level1']/font")
          message = nodes.at(0).inner_text

          if message =~ /blacklist/
            return :error, message
          end

          return :ok, message
        end
      end
    end
  end
end