#
# This file is part of the Poke package
#
# (c) 2014 Julien Brochet <mewt@madalynn.eu>
#
# For the full copyright and license information, please view the LICENSE
# file that was distributed with this source code.
#

require 'nokogiri'
require 'open-uri'

module Poke
  module Checks
    module Blacklist
      class SpamcopBlacklistCheck < Poke::Check
        def initialize(ip)
          name = "Blacklist of #{ip} (Spamcop)"
          @ip = ip
          super name
        end

        # Run the check
        def run
          html = URI.parse("http://www.spamcop.net/w3m?action=checkblock&ip=#{@ip}").read
          doc = Nokogiri::HTML(html)
          nodes = doc.search("//div[@id='content']/p")
          message = nodes.at(0).inner_text

          if message =~ /not listed/
            return :ok, message
          end

          return :error, message
        end
      end
    end
  end
end